#lang racket

#|
(define (factorial n)
  (cond [(= n 0) 1]
        [else (* n (factorial (- n 1)))]))
|#

(define (if b then-branch else-branch)
  (cond [b (then-branch)]
        [else (else-branch)]))

(define (factorial n)
  (if (= n 0)
    (thunk 1)
    (thunk (* n (factorial (- n 1))))))

;(factorial 10)

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(define (runner count th call-back)
  (cond [(<= count 0) (call-back (th) th)] ; invokes thunk once, and passes it along
        [else (call-back count th)]))         ; does not invoke thunk once


(define (thunk-repeat n th)
  (cond [(<= n 0) 0]
        [else
          (+ (th) (thunk-repeat (- n 1) th))]))
#|
(thunk-repeat 3
  (thunk (sleep 2) (display ".\n") 3))
|#
(define (promise-repeat n th)
  (cond [(<= n 0) 0]
        [else
          (+ (force th) (promise-repeat (- n 1) th))]))

#|
(promise-repeat 3
  (delay (sleep 2) (display "*\n") 3))
|#
(struct prom (func executed?) #:transparent)

(define (make-prom th)
  (prom th #f))

(define (sync p)
  (cond [(prom-executed? p) p]
        [else
          (define the-thunk (prom-func p))
          (define result (the-thunk))
          (prom result #t)]))

(define p (make-prom (thunk (sleep 1) (display "!!!") 100)))
p
(define new-p (sync p))
new-p
(sync new-p)

(define (do-force p)
  (cond [(prom-executed? p) (prom-func p)]
        [else (error "Call sync first!")]))
(do-force new-p)
(do-force p)






















;